package trade_UpdateTradeLimitTemplate_request

import (
	"encoding/json"
	trade_UpdateTradeLimitTemplate_response "git.rosy.net.cn/baseapi/platformapi/tiktok_shop/sdk-golang/api/trade_UpdateTradeLimitTemplate/response"
	doudian_sdk "git.rosy.net.cn/baseapi/platformapi/tiktok_shop/sdk-golang/core"
)

type TradeUpdateTradeLimitTemplateRequest struct {
	doudian_sdk.BaseDoudianOpApiRequest
	Param *TradeUpdateTradeLimitTemplateParam
}

func (c *TradeUpdateTradeLimitTemplateRequest) GetUrlPath() string {
	return "/trade/UpdateTradeLimitTemplate"
}

func New() *TradeUpdateTradeLimitTemplateRequest {
	request := &TradeUpdateTradeLimitTemplateRequest{
		Param: &TradeUpdateTradeLimitTemplateParam{},
	}
	request.SetConfig(doudian_sdk.GlobalConfig)
	request.SetClient(doudian_sdk.DefaultDoudianOpApiClient)
	return request

}

func (c *TradeUpdateTradeLimitTemplateRequest) Execute(accessToken *doudian_sdk.AccessToken) (*trade_UpdateTradeLimitTemplate_response.TradeUpdateTradeLimitTemplateResponse, error) {
	responseJson, err := c.GetClient().Request(c, accessToken)
	if err != nil {
		return nil, err
	}
	response := &trade_UpdateTradeLimitTemplate_response.TradeUpdateTradeLimitTemplateResponse{}
	_ = json.Unmarshal([]byte(responseJson), response)
	return response, nil

}

func (c *TradeUpdateTradeLimitTemplateRequest) GetParamObject() interface{} {
	return c.Param
}

func (c *TradeUpdateTradeLimitTemplateRequest) GetParams() *TradeUpdateTradeLimitTemplateParam {
	return c.Param
}

type TradeLimitRuleRequestListItem struct {
	// 限购模型 1-重量，2-数量，3-地区，4-金额
	TradeLimitModel int32 `json:"trade_limit_model"`
	// 限购资源类别1-抖店，2-门店，3-商品ID，4-sku,5-类目，6-活动，7-商品标
	TradeLimitResource int32 `json:"trade_limit_resource"`
	// 限购资源值
	//TradeLimitResourceObject *TradeLimitResourceObject `json:"trade_limit_resource_object"`
	// 限购值，模型为重量则单位为毫克，模型为金额则单位为分
	TradeLimitPattern *TradeLimitPattern `json:"trade_limit_pattern"`
	// 限购时间
	//TimePeriod *TimePeriod `json:"time_period"`
	// 限购维度1 // 端用户（比如uid=122，aid=1128） 2 // 用户组用户（比如uid=122，group=aweme） 3 // 设备 4 // 下单电话 5 // 收件电话 6 // 身份证号 7 // 支付账号
	TradeLimitSubjectLisit []int32 `json:"trade_limit_subject_lisit"`
}
type TradeUpdateTradeLimitTemplateParam struct {
	// 限购模板ID
	TradeLimitTemplateId int64 `json:"trade_limit_template_id"`
	// 限购参数
	TradeLimitRuleRequestList []TradeLimitRuleRequestListItem `json:"trade_limit_rule_request_list"`
}
type TradeLimitResourceObject struct {
	// 限购资源值列表
	TradeLimitResourceIdList []string `json:"trade_limit_resource_id_list"`
}
type TradeLimitPattern struct {
	// 单次下限
	Minimum int64 `json:"minimum"`
	// 单次上限
	Maximum int64 `json:"maximum"`
	// 累计限购值
	CumulativeMax int64 `json:"cumulative_max"`
}
type TimePeriodFixed struct {
	// 开始时间
	StartTime int64 `json:"start_time"`
	// 结束时间
	EndTime int64 `json:"end_time"`
}
type TimePeriod struct {
	// 限购时间类型
	TimePeriodPattern int32 `json:"time_period_pattern"`
	// 限购时间滑动窗口
	TimePeriodFixed *TimePeriodFixed `json:"time_period_fixed"`
}
